export const panda = `<?xml version="1.0" ?>
<!-- =================================================================================== -->
<!-- |    This document was autogenerated by xacro from franka_description/robots/panda_arm_hand.urdf.xacro | -->
<!-- |    EDITING THIS FILE BY HAND IS NOT RECOMMENDED                                 | -->
<!-- =================================================================================== -->
<robot name="panda">
  <link name="panda_link0">
  <visual>
    <geometry>
    <mesh filename="package://franka_ros/franka_description/meshes/visual/link0.dae"/>
  </geometry>
</visual>
<collision>
  <origin rpy="0 0 0" xyz="-0.04 0 0.06"/>
  <geometry>
    <box size="0.23 0.2 0.15"/>
  </geometry>
</collision>
  </link>
  <link name="panda_link1">
    <visual>
      <geometry>
        <mesh filename="package://franka_ros/franka_description/meshes/visual/link1.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="0 0 0" xyz="0 0.0 -0.13"/>
      <geometry>
        <capsule length="0.06" radius="0.06"/>
      </geometry>
    </collision>
    <collision>
      <origin rpy="1.5707963267948966 0 0" xyz="0 0 0"/>
      <geometry>
        <capsule length="0.135" radius="0.06"/>
      </geometry>
    </collision>
    <inertial>
      <origin rpy="0 0 0" xyz="3.875e-03 2.081e-03 -0.1750"/>
      <mass value="4.970684"/>
      <inertia ixx="7.0337e-01" ixy="-1.3900e-04" ixz="6.7720e-03" iyy="7.0661e-01" iyz="1.9169e-02" izz="9.1170e-03"/>
    </inertial>
  </link>
  <joint name="panda_joint1" type="revolute">
    <safety_controller k_position="100.0" k_velocity="40.0" soft_lower_limit="-2.8973" soft_upper_limit="2.8973"/>
    <origin rpy="0 0 0" xyz="0 0 0.333"/>
    <parent link="panda_link0"/>
    <child link="panda_link1"/>
    <axis xyz="0 0 1"/>
    <limit effort="87" lower="-2.8973" upper="2.8973" velocity="2.1750"/>
  </joint>
  <link name="panda_link2">
    <visual>
      <geometry>
        <mesh filename="package://franka_ros/franka_description/meshes/visual/link2.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="-1.5707963267948966 0 0" xyz="0 -0.18 0.0"/>
      <geometry>
        <capsule length="0.11" radius="0.06"/>
      </geometry>
    </collision>
    <inertial>
      <origin rpy="0 0 0" xyz="-3.141e-03 -2.872e-02 3.495e-03"/>
      <mass value="0.646926"/>
      <inertia ixx="7.9620e-03" ixy="-3.9250e-03" ixz="1.0254e-02" iyy="2.8110e-02" iyz="7.0400e-04" izz="2.5995e-02"/>
    </inertial>
  </link>
  <joint name="panda_joint2" type="revolute">
    <safety_controller k_position="100.0" k_velocity="40.0" soft_lower_limit="-1.7628" soft_upper_limit="1.7628"/>
    <origin rpy="-1.5707963267948966 0 0" xyz="0 0 0"/>
    <parent link="panda_link1"/>
    <child link="panda_link2"/>
    <axis xyz="0 0 1"/>
    <limit effort="87" lower="-1.7628" upper="1.7628" velocity="2.1750"/>
  </joint>
  <link name="panda_link3">
    <visual>
      <geometry>
        <mesh filename="package://franka_ros/franka_description/meshes/visual/link3.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 0 0" xyz="0.08 0.0 0"/>
      <geometry>
        <capsule length="0.11" radius="0.055"/>
      </geometry>
    </collision>
    <inertial>
      <origin rpy="0 0 0" xyz="2.7518e-02 3.9252e-02 -6.6502e-02"/>
      <mass value="3.228604"/>
      <inertia ixx="3.7242e-02" ixy="-4.7610e-03" ixz="-1.1396e-02" iyy="3.6155e-02" iyz="-1.2805e-02" izz="1.0830e-02"/>
    </inertial>
  </link>
  <joint name="panda_joint3" type="revolute">
    <safety_controller k_position="100.0" k_velocity="40.0" soft_lower_limit="-2.8973" soft_upper_limit="2.8973"/>
    <origin rpy="1.5707963267948966 0 0" xyz="0 -0.316 0"/>
    <parent link="panda_link2"/>
    <child link="panda_link3"/>
    <axis xyz="0 0 1"/>
    <limit effort="87" lower="-2.8973" upper="2.8973" velocity="2.1750"/>
  </joint>
  <link name="panda_link4">
    <visual>
      <geometry>
        <mesh filename="package://franka_ros/franka_description/meshes/visual/link4.dae"/>
      </geometry>
    </visual>
    <inertial>
      <origin rpy="0 0 0" xyz="-5.317e-02 1.04419e-01 2.7454e-02"/>
      <mass value="3.587895"/>
      <inertia ixx="2.5853e-02" ixy="7.7960e-03" ixz="-1.3320e-03" iyy="1.9552e-02" iyz="8.6410e-03" izz="2.8323e-02"/>
    </inertial>
  </link>
  <joint name="panda_joint4" type="revolute">
    <safety_controller k_position="100.0" k_velocity="40.0" soft_lower_limit="-3.0718" soft_upper_limit="-0.0698"/>
    <origin rpy="1.5707963267948966 0 0" xyz="0.0825 0 0"/>
    <parent link="panda_link3"/>
    <child link="panda_link4"/>
    <axis xyz="0 0 1"/>
    <limit effort="87" lower="-3.0718" upper="-0.0698" velocity="2.1750"/>
  </joint>
  <link name="panda_link5">
    <visual>
      <geometry>
        <mesh filename="package://franka_ros/franka_description/meshes/visual/link5.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="0 0 0" xyz="0.0 0 -0.27"/>
      <geometry>
        <capsule length="0.09" radius="0.055"/>
      </geometry>
    </collision>
    <collision>
      <origin rpy="-0.2 0 0" xyz="0 0.08 -0.1"/>
      <geometry>
        <box size="0.07 0.07 0.2"/>
      </geometry>
    </collision>
    <collision>
      <origin rpy="1.5707963267948966 0 0" xyz="0.0 0.04 0"/>
      <geometry>
        <capsule length="0.1" radius="0.045"/>
      </geometry>
    </collision>
    <inertial>
      <origin rpy="0 0 0" xyz="-1.1953e-02 4.1065e-02 -3.8437e-02"/>
      <mass value="1.225946"/>
      <inertia ixx="3.5549e-02" ixy="-2.1170e-03" ixz="-4.0370e-03" iyy="2.9474e-02" iyz="2.2900e-04" izz="8.6270e-03"/>
    </inertial>
  </link>
  <joint name="panda_joint5" type="revolute">
    <safety_controller k_position="100.0" k_velocity="40.0" soft_lower_limit="-2.8973" soft_upper_limit="2.8973"/>
    <origin rpy="-1.5707963267948966 0 0" xyz="-0.0825 0.384 0"/>
    <parent link="panda_link4"/>
    <child link="panda_link5"/>
    <axis xyz="0 0 1"/>
    <limit effort="12" lower="-2.8973" upper="2.8973" velocity="2.6100"/>
  </joint>
  <link name="panda_link6">
    <visual>
      <geometry>
        <mesh filename="package://franka_ros/franka_description/meshes/visual/link6.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 0 0" xyz="0.09 0.014 0.0"/>
      <geometry>
        <cylinder length="0.12" radius="0.04"/>
      </geometry>
    </collision>
    <inertial>
      <origin rpy="0 0 0" xyz="6.0149e-02 -1.4117e-02 -1.0517e-02"/>
      <mass value="1.666555"/>
      <inertia ixx="1.9640e-03" ixy="1.0900e-04" ixz="-1.1580e-03" iyy="4.3540e-03" iyz="3.4100e-04" izz="5.4330e-03"/>
    </inertial>
  </link>
  <joint name="panda_joint6" type="revolute">
    <safety_controller k_position="100.0" k_velocity="40.0" soft_lower_limit="-0.0175" soft_upper_limit="3.7525"/>
    <origin rpy="1.5707963267948966 0 0" xyz="0 0 0"/>
    <parent link="panda_link5"/>
    <child link="panda_link6"/>
    <axis xyz="0 0 1"/>
    <limit effort="12" lower="-0.0175" upper="3.7525" velocity="2.6100"/>
  </joint>
  <link name="panda_link7">
    <visual>
      <geometry>
        <mesh filename="package://franka_ros/franka_description/meshes/visual/link7.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="0 0 0" xyz="0 0.005 0.07"/>
      <geometry>
        <cylinder length="0.04" radius="0.045"/>
      </geometry>
    </collision>
    <collision>
      <origin rpy="0 0 0.8" xyz="0.04 0.04 0.08"/>
      <geometry>
        <box size="0.07 0.07 0.03"/>
      </geometry>
    </collision>
    <inertial>
      <origin rpy="0 0 0" xyz="1.0517e-02 -4.252e-03 6.1597e-02"/>
      <mass value="7.35522e-01"/>
      <inertia ixx="1.2516e-02" ixy="-4.2800e-04" ixz="-1.1960e-03" iyy="1.0027e-02" iyz="-7.4100e-04" izz="4.8150e-03"/>
    </inertial>
  </link>
  <joint name="panda_joint7" type="revolute">
    <safety_controller k_position="100.0" k_velocity="40.0" soft_lower_limit="-2.8973" soft_upper_limit="2.8973"/>
    <origin rpy="1.5707963267948966 0 0" xyz="0.088 0 0"/>
    <parent link="panda_link6"/>
    <child link="panda_link7"/>
    <axis xyz="0 0 1"/>
    <limit effort="12" lower="-2.8973" upper="2.8973" velocity="2.6100"/>
  </joint>
  <link name="panda_link8">
    <inertial>
        <origin xyz="0 0 0" rpy="0 0 0"/>
        <mass value="0.0"/>
        <inertia ixx="0.001" ixy="0.0" ixz="0.0" iyy="0.001" iyz="0.0" izz="0.001"/>
      </inertial>
  </link>
  <joint name="panda_joint8" type="fixed">
    <origin rpy="0 0 0" xyz="0 0 0.107"/>
    <parent link="panda_link7"/>
    <child link="panda_link8"/>
  </joint>
  <joint name="panda_hand_joint" type="fixed">
    <parent link="panda_link8"/>
    <child link="panda_hand"/>
    <origin rpy="0 0 -0.7853981633974483" xyz="0 0 0"/>
  </joint>
  <link name="panda_hand">
    <visual>
      <geometry>
        <mesh filename="package://franka_ros/franka_description/meshes/visual/hand.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="0 0 0" xyz="0.0 0.0 0.03"/>
      <geometry>
        <box size="0.04 0.2 0.08"/>
      </geometry>
    </collision>
    <inertial>
        <origin rpy="0 0 0" xyz="0 0.0015244 0.0275912"/>
        <mass value="0.73"/>
        <inertia ixx="0.00278560230025" ixy="0.0" ixz="0.0" iyy="0.000400033405336" iyz="0.0" izz="0.00256378041832"/>
      </inertial>
  </link>
  <link name="panda_leftfinger">
    <visual>
      <geometry>
        <mesh filename="package://franka_ros/franka_description/meshes/visual/finger.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="0 0 0" xyz="0.0 0.012 0.033"/>
      <geometry>
        <box size="0.02 0.025 0.041"/>
      </geometry>
    </collision>
    <inertial>
        <origin rpy="0 0 0" xyz="0 0.0145644 0.0227941"/>
        <mass value="0.1"/>
        <inertia ixx="3.01220925051e-05" ixy="0.0" ixz="0.0" iyy="2.95873808038e-05" iyz="0.0" izz="6.95125211657e-06"/>
    </inertial>
  </link>
  <link name="panda_rightfinger">
    <visual>
      <origin rpy="0 0 3.141592653589793" xyz="0 0 0"/>
      <geometry>
        <mesh filename="package://franka_ros/franka_description/meshes/visual/finger.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="0 0 0" xyz="0.0 -0.012 0.033"/>
      <geometry>
        <box size="0.02 0.025 0.041"/>
      </geometry>
    </collision>
    <inertial>
        <origin rpy="0 0 3.141592653589793" xyz="0 -0.0145644 0.0227941"/>
        <mass value="0.1"/>
        <inertia ixx="3.01220925051e-05" ixy="0.0" ixz="0.0" iyy="2.95873808038e-05" iyz="0.0" izz="6.95125211657e-06"/>
      </inertial>
  </link>
  <joint name="panda_finger_joint1" type="prismatic">
    <parent link="panda_hand"/>
    <child link="panda_leftfinger"/>
    <origin rpy="0 0 0" xyz="0 0 0.0584"/>
    <axis xyz="0 1 0"/>
    <limit effort="20" lower="0.0" upper="0.04" velocity="0.2"/>
  </joint>
  <joint name="panda_finger_joint2" type="prismatic">
    <parent link="panda_hand"/>
    <child link="panda_rightfinger"/>
    <origin rpy="0 0 0" xyz="0 0 0.0584"/>
    <axis xyz="0 -1 0"/>
    <limit effort="20" lower="0.0" upper="0.04" velocity="0.2"/>
    <mimic joint="panda_finger_joint1"/>
  </joint>
</robot>`;

export const ur3e = `<?xml version="1.0" ?>
<!-- =================================================================================== -->
<!-- |    This document was autogenerated by xacro from src/universal_robot/ur_description/urdf/ur3.xacro | -->
<!-- |    EDITING THIS FILE BY HAND IS NOT RECOMMENDED                                 | -->
<!-- =================================================================================== -->
<robot name="ur3_robot">
  <!--
    Base UR robot series xacro macro.

    NOTE: this is NOT a URDF. It cannot directly be loaded by consumers
    expecting a flattened '.urdf' file. See the top-level '.xacro' for that
    (but note: that .xacro must still be processed by the xacro command).

    For use in '.launch' files: use one of the 'load_urX.launch' convenience
    launch files.

    This file models the base kinematic chain of a UR robot, which then gets
    parameterised by various configuration files to convert it into a UR3(e),
    UR5(e), UR10(e) or UR16e.

    NOTE: the default kinematic parameters (ie: link lengths, frame locations,
    offets, etc) do not correspond to any particular robot. They are defaults
    only. There WILL be non-zero offsets between the Forward Kinematics results
    in TF (ie: robot_state_publisher) and the values reported by the Teach
    Pendant.

    For accurate (and robot-specific) transforms, the 'kinematics_parameters_file'
    parameter MUST point to a .yaml file containing the appropriate values for
    the targetted robot.

    If using the UniversalRobots/Universal_Robots_ROS_Driver, follow the steps
    described in the readme of that repository to extract the kinematic
    calibration from the controller and generate the required .yaml file.

    Main author of the migration to yaml configs: Ludovic Delval.

    Contributors to previous versions (in no particular order):

     - Felix Messmer
     - Kelsey Hawkins
     - Wim Meeussen
     - Shaun Edwards
     - Nadia Hammoudeh Garcia
     - Dave Hershberger
     - G. vd. Hoorn
     - Philip Long
     - Dave Coleman
     - Miguel Prada
     - Mathias Luedtke
     - Marcel Schnirring
     - Felix von Drigalski
     - Felix Exner
     - Jimmy Da Silva
     - Ajit Krisshna N L
     - Muhammad Asif Rana
  -->
  <!--
    NOTE: the macro defined in this file is NOT part of the public API of this
          package. Users CANNOT rely on this file being available, or stored in
          this location. Nor can they rely on the existence of the macro.
  -->
  <!-- links: main serial chain -->
  <link name="base_link">
    <visual>
      <origin rpy="0 0 3.141592653589793" xyz="0 0 0.0"/>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur3/visual/base.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="0 0 3.141592653589793" xyz="0 0 0.04"/>
      <geometry>
        <cylinder length="0.09" radius="0.065"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="2.0"/>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <inertia ixx="0.0030531654454" ixy="0.0" ixz="0.0" iyy="0.0030531654454" iyz="0.0" izz="0.005625"/>
    </inertial>
  </link>
  <link name="shoulder_link">
    <visual>
      <origin rpy="0 0 3.141592653589793" xyz="0 0 0"/>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur3/visual/shoulder.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="0 0 3.141592653589793" xyz="0 0 0"/>
      <geometry>
        <cylinder length="0.11" radius="0.065"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="2.0"/>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <inertia ixx="0.008093163429399999" ixy="0.0" ixz="0.0" iyy="0.008093163429399999" iyz="0.0" izz="0.005625"/>
    </inertial>
  </link>
  <link name="upper_arm_link">
    <visual>
      <origin rpy="1.5707963267948966 0 -1.5707963267948966" xyz="0 0 0.12"/>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur3/visual/upperarm.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 0 -1.5707963267948966" xyz="-0.127 0 0.12"/>
      <geometry>
        <cylinder length="0.145" radius="0.05"/>
      </geometry>
    </collision>
    <collision>
      <origin rpy="0 0 -1.5707963267948966" xyz="0 0 0.125"/>
      <geometry>
        <cylinder length="0.11" radius="0.05"/>
      </geometry>
    </collision>
    <collision>
      <origin rpy="0 0 -1.5707963267948966" xyz="-0.245 0 0.125"/>
      <geometry>
        <cylinder length="0.11" radius="0.04"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="3.42"/>
      <origin rpy="0 1.5707963267948966 0" xyz="-0.121825 0.0 0.12"/>
      <inertia ixx="0.021728483221103233" ixy="0.0" ixz="0.0" iyy="0.021728483221103233" iyz="0.0" izz="0.00961875"/>
    </inertial>
  </link>
  <link name="forearm_link">
    <visual>
      <origin rpy="1.5707963267948966 0 -1.5707963267948966" xyz="0 0 0.027"/>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur3/visual/forearm.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 0 -1.5707963267948966" xyz="-0.07 0 0.027"/>
      <geometry>
        <cylinder length="0.20" radius="0.04"/>
      </geometry>
    </collision>
    <collision>
      <origin rpy="0 0 -1.5707963267948966" xyz="-0.215 0 0.027"/>
      <geometry>
        <cylinder length="0.095" radius="0.04"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="1.26"/>
      <origin rpy="0 1.5707963267948966 0" xyz="-0.1066 0.0 0.027"/>
      <inertia ixx="0.0065445675821719194" ixy="0.0" ixz="0.0" iyy="0.0065445675821719194" iyz="0.0" izz="0.00354375"/>
    </inertial>
  </link>
  <link name="wrist_1_link">
    <visual>
      <!-- TODO: Move this to a parameter -->
      <origin rpy="1.5707963267948966 0 0" xyz="0 0 -0.104"/>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur3/visual/wrist1.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 0 0" xyz="0 0 0"/>
      <geometry>
        <cylinder length="0.095" radius="0.035"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="0.8"/>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <inertia ixx="0.002084999166" ixy="0.0" ixz="0.0" iyy="0.002084999166" iyz="0.0" izz="0.00225"/>
    </inertial>
  </link>
  <link name="wrist_2_link">
    <visual>
      <origin rpy="0 0 0" xyz="0 0 -0.08535"/>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur3/visual/wrist2.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 0 0" xyz="0 -0.008 0.005"/>
      <geometry>
        <cylinder length="0.1" radius="0.04"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="0.8"/>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <inertia ixx="0.002084999166" ixy="0.0" ixz="0.0" iyy="0.002084999166" iyz="0.0" izz="0.00225"/>
    </inertial>
  </link>
  <link name="wrist_3_link">
    <visual>
      <origin rpy="1.5707963267948966 0 0" xyz="0 -0.0 -0.081"/>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur3/visual/wrist3.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="0 0 0" xyz="0.005 0 -0.015"/>
      <geometry>
        <cylinder length="0.04" radius="0.04"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="0.35"/>
      <origin rpy="0 0 0" xyz="0.0 0.0 -0.02"/>
      <inertia ixx="0.00013626661215999998" ixy="0.0" ixz="0.0" iyy="0.00013626661215999998" iyz="0.0" izz="0.0001792"/>
    </inertial>
  </link>
  <!-- joints: main serial chain -->
  <joint name="shoulder_pan_joint" type="revolute">
    <parent link="base_link_inertia"/>
    <child link="shoulder_link"/>
    <origin rpy="0 0 0" xyz="0 0 0.1519"/>
    <axis xyz="0 0 1"/>
    <limit effort="56.0" lower="-6.283185307179586" upper="6.283185307179586" velocity="3.141592653589793"/>
    <dynamics damping="0" friction="0"/>
  </joint>
  <joint name="shoulder_lift_joint" type="revolute">
    <parent link="shoulder_link"/>
    <child link="upper_arm_link"/>
    <origin rpy="1.570796327 0 0" xyz="0 0 0"/>
    <axis xyz="0 0 1"/>
    <limit effort="56.0" lower="-6.283185307179586" upper="6.283185307179586" velocity="3.141592653589793"/>
    <dynamics damping="0" friction="0"/>
  </joint>
  <joint name="elbow_joint" type="revolute">
    <parent link="upper_arm_link"/>
    <child link="forearm_link"/>
    <origin rpy="0 0 0" xyz="-0.24365 0 0"/>
    <axis xyz="0 0 1"/>
    <limit effort="28.0" lower="-3.141592653589793" upper="3.141592653589793" velocity="3.141592653589793"/>
    <dynamics damping="0" friction="0"/>
  </joint>
  <joint name="wrist_1_joint" type="revolute">
    <parent link="forearm_link"/>
    <child link="wrist_1_link"/>
    <origin rpy="0 0 0" xyz="-0.21325 0 0.11235"/>
    <axis xyz="0 0 1"/>
    <limit effort="12.0" lower="-6.283185307179586" upper="6.283185307179586" velocity="6.283185307179586"/>
    <dynamics damping="0" friction="0"/>
  </joint>
  <joint name="wrist_2_joint" type="revolute">
    <parent link="wrist_1_link"/>
    <child link="wrist_2_link"/>
    <origin rpy="1.570796327 0 0" xyz="0 -0.08535 -1.750557762378351e-11"/>
    <axis xyz="0 0 1"/>
    <limit effort="12.0" lower="-6.283185307179586" upper="6.283185307179586" velocity="6.283185307179586"/>
    <dynamics damping="0" friction="0"/>
  </joint>
  <joint name="wrist_3_joint" type="revolute">
    <parent link="wrist_2_link"/>
    <child link="wrist_3_link"/>
    <origin rpy="1.570796326589793 3.141592653589793 3.141592653589793" xyz="0 0.0819 -1.679797079540562e-11"/>
    <axis xyz="0 0 1"/>
    <limit effort="12.0" lower="-6.283185307179586" upper="6.283185307179586" velocity="6.283185307179586"/>
    <dynamics damping="0" friction="0"/>
  </joint>
  <!-- ROS-Industrial 'base' frame: base_link to UR 'Base' Coordinates transform -->
  <link name="base"/>
  <joint name="base_link-base_fixed_joint" type="fixed">
    <!-- Note the rotation over Z of pi radians: as base_link is REP-103
           aligned (ie: has X+ forward, Y+ left and Z+ up), this is needed
           to correctly align 'base' with the 'Base' coordinate system of
           the UR controller.
      -->
    <origin rpy="0 0 0" xyz="0 0 0"/>
    <parent link="base_link"/>
    <child link="base"/>
  </joint>
  <!-- ROS-Industrial 'flange' frame: attachment point for EEF models -->
  <link name="flange"/>
  <joint name="wrist_3-flange" type="fixed">
    <parent link="wrist_3_link"/>
    <child link="flange"/>
    <origin rpy="0 -1.5707963267948966 -1.5707963267948966" xyz="0 0 0"/>
  </joint>
  <!-- ROS-Industrial 'tool0' frame: all-zeros tool frame -->
  <link name="tool0"/>
  <joint name="flange-tool0" type="fixed">
    <!-- default toolframe: X+ left, Y+ up, Z+ front -->
    <origin rpy="1.5707963267948966 0 1.5707963267948966" xyz="0 0 0"/>
    <parent link="flange"/>
    <child link="tool0"/>
  </joint>
  <joint name="robotiq_85_base_joint" type="fixed">
    <parent link="flange"/>
    <child link="robotiq_85_base_link"/>
  </joint>

  <link name="robotiq_85_base_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_base_link.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="0 0 0" xyz="0.07 0 0"/>
      <geometry>
        <box size="0.12 0.12 0.07"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="0.636951" />
      <origin xyz="0.0 0.0 0.0" />
      <inertia ixx = "0.000380" ixy = "0.000000" ixz = "0.000000"
           iyx = "0.000000" iyy = "0.001110" iyz = "0.000000"
           izx = "0.000000" izy = "0.000000" izz = "0.001171" />
    </inertial>
  </link>

  <joint name="robotiq_85_left_knuckle_joint" type="revolute">
    <parent link="robotiq_85_base_link"/>
    <child link="robotiq_85_left_knuckle_link"/>
    <axis xyz="0 0 1"/>
    <origin rpy="3.14159265359 0.0 0.0" xyz="0.05490451627 0.03060114443 0.0"/>
    <limit effort="1000" lower="0.0" upper="0.80285" velocity="0.5"/>
  </joint>
  <joint name="robotiq_85_right_knuckle_joint" type="continuous">
    <parent link="robotiq_85_base_link"/>
    <child link="robotiq_85_right_knuckle_link"/>
    <axis xyz="0 0 1"/>
    <origin rpy="0.0 0.0 0.0" xyz="0.05490451627 -0.03060114443 0.0"/>
    <limit effort="1000" lower="-3.14" upper="3.14" velocity="100.0"/>
    <mimic joint="robotiq_85_left_knuckle_joint"/>
  </joint>
  <link name="robotiq_85_left_knuckle_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_knuckle_link.dae"/>
      </geometry>
    </visual>
    <inertial>
      <mass value="0.018491"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000009" ixy="-0.000001" ixz="0.000000" iyy="0.000001" iyz="0.000000" izz="0.000010"/>
    </inertial>
  </link>
  <link name="robotiq_85_right_knuckle_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_knuckle_link.dae"/>
      </geometry>
    </visual>
    <inertial>
      <mass value="0.018491"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000009" ixy="-0.000001" ixz="0.000000" iyy="0.000001" iyz="0.000000" izz="0.000010"/>
    </inertial>
  </link>

  <joint name="robotiq_85_left_finger_joint" type="fixed">
    <parent link="robotiq_85_left_knuckle_link"/>
    <child link="robotiq_85_left_finger_link"/>
    <origin rpy="0 0 0" xyz="-0.00408552455 -0.03148604435 0.0"/>
  </joint>
  <joint name="robotiq_85_right_finger_joint" type="fixed">
    <parent link="robotiq_85_right_knuckle_link"/>
    <child link="robotiq_85_right_finger_link"/>
    <origin rpy="0 0 0" xyz="-0.00408552455 -0.03148604435 0.0"/>
  </joint>
  <link name="robotiq_85_left_finger_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_finger_link.dae"/>
      </geometry>
    </visual>
    <inertial>
      <mass value="0.027309"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000003" ixy="-0.000002" ixz="0.000000" iyy="0.000021" iyz="0.000000" izz="0.000020"/>
    </inertial>
  </link>
  <link name="robotiq_85_right_finger_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_finger_link.dae"/>
      </geometry>
    </visual>
    <inertial>
      <mass value="0.027309"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000003" ixy="-0.000002" ixz="0.000000" iyy="0.000021" iyz="0.000000" izz="0.000020"/>
    </inertial>
  </link>

  <joint name="robotiq_85_left_inner_knuckle_joint" type="continuous">
    <parent link="robotiq_85_base_link"/>
    <child link="robotiq_85_left_inner_knuckle_link"/>
    <axis xyz="0 0 1"/>
    <origin rpy="3.14159265359 0.0 0.0" xyz="0.06142 0.0127 0"/>
    <limit effort="0.1" lower="-3.14" upper="3.14" velocity="100.0"/>
    <mimic joint="robotiq_85_left_knuckle_joint" offset="0"/>
  </joint>
  <joint name="robotiq_85_right_inner_knuckle_joint" type="continuous">
    <parent link="robotiq_85_base_link"/>
    <child link="robotiq_85_right_inner_knuckle_link"/>
    <axis xyz="0 0 1"/>
    <origin rpy="0 0 0" xyz="0.06142 -0.0127 0"/>
    <limit effort="0.1" lower="-3.14" upper="3.14" velocity="100.0"/>
    <mimic joint="robotiq_85_left_knuckle_joint" offset="0"/>
  </joint>
  <link name="robotiq_85_left_inner_knuckle_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_inner_knuckle_link.dae"/>
      </geometry>
    </visual>
    <inertial>
      <mass value="0.029951"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000039" ixy="0.000000" ixz="0.000000" iyy="0.000005" iyz="0.000000" izz="0.000035"/>
    </inertial>
  </link>
  <link name="robotiq_85_right_inner_knuckle_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_inner_knuckle_link.dae"/>
      </geometry>
    </visual>
    <inertial>
      <mass value="0.029951"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000039" ixy="0.000000" ixz="0.000000" iyy="0.000005" iyz="0.000000" izz="0.000035"/>
    </inertial>
  </link>

  <joint name="robotiq_85_left_finger_tip_joint" type="continuous">
    <parent link="robotiq_85_left_inner_knuckle_link"/>
    <child link="robotiq_85_left_finger_tip_link"/>
    <axis xyz="0 0 1"/>
    <origin rpy="0.0 0.0 0.0" xyz="0.04303959807 -0.03759940821 0.0"/>
    <limit effort="0.1" lower="-3.14" upper="3.14" velocity="100.0"/>
    <mimic joint="robotiq_85_left_knuckle_joint" multiplier="-1"/>
  </joint>
  <joint name="robotiq_85_right_finger_tip_joint" type="continuous">
    <parent link="robotiq_85_right_inner_knuckle_link"/>
    <child link="robotiq_85_right_finger_tip_link"/>
    <axis xyz="0 0 1"/>
    <origin rpy="0.0 0.0 0.0" xyz="0.04303959807 -0.03759940821  0.0"/>
    <limit effort="0.1" lower="-3.14" upper="3.14" velocity="100.0"/>
    <mimic joint="robotiq_85_left_knuckle_joint" multiplier="-1"/>
  </joint>
  <link name="robotiq_85_left_finger_tip_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_finger_tip_link.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="0 0 0" xyz="0.03 0 0"/>
      <geometry>
        <box size="0.03 0.013 0.02"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="0.019555"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000002" ixy="0.000000" ixz="0.000000" iyy="0.000005" iyz="0.000000" izz="0.000006"/>
    </inertial>
  </link>
  <link name="robotiq_85_right_finger_tip_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_finger_tip_link.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="0 0 0" xyz="0.03 0 0"/>
      <geometry>
        <box size="0.03 0.013 0.02"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="0.019555"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000002" ixy="0.000000" ixz="0.000000" iyy="0.000005" iyz="0.000000" izz="0.000006"/>
    </inertial>
  </link>
</robot>`;

export const ur5e = `<?xml version="1.0" ?>
<!-- =================================================================================== -->
<!-- |    This document was autogenerated by xacro from src/universal_robot/ur_description/urdf/ur5.xacro | -->
<!-- |    EDITING THIS FILE BY HAND IS NOT RECOMMENDED                                 | -->
<!-- =================================================================================== -->
<robot name="ur5_robot">
  <!--
    Base UR robot series xacro macro.

    NOTE: this is NOT a URDF. It cannot directly be loaded by consumers
    expecting a flattened '.urdf' file. See the top-level '.xacro' for that
    (but note: that .xacro must still be processed by the xacro command).

    For use in '.launch' files: use one of the 'load_urX.launch' convenience
    launch files.

    This file models the base kinematic chain of a UR robot, which then gets
    parameterised by various configuration files to convert it into a UR3(e),
    UR5(e), UR10(e) or UR16e.

    NOTE: the default kinematic parameters (ie: link lengths, frame locations,
    offets, etc) do not correspond to any particular robot. They are defaults
    only. There WILL be non-zero offsets between the Forward Kinematics results
    in TF (ie: robot_state_publisher) and the values reported by the Teach
    Pendant.

    For accurate (and robot-specific) transforms, the 'kinematics_parameters_file'
    parameter MUST point to a .yaml file containing the appropriate values for
    the targetted robot.

    If using the UniversalRobots/Universal_Robots_ROS_Driver, follow the steps
    described in the readme of that repository to extract the kinematic
    calibration from the controller and generate the required .yaml file.

    Main author of the migration to yaml configs: Ludovic Delval.

    Contributors to previous versions (in no particular order):

     - Felix Messmer
     - Kelsey Hawkins
     - Wim Meeussen
     - Shaun Edwards
     - Nadia Hammoudeh Garcia
     - Dave Hershberger
     - G. vd. Hoorn
     - Philip Long
     - Dave Coleman
     - Miguel Prada
     - Mathias Luedtke
     - Marcel Schnirring
     - Felix von Drigalski
     - Felix Exner
     - Jimmy Da Silva
     - Ajit Krisshna N L
     - Muhammad Asif Rana
  -->
  <!--
    NOTE: the macro defined in this file is NOT part of the public API of this
          package. Users CANNOT rely on this file being available, or stored in
          this location. Nor can they rely on the existence of the macro.
  -->
  <!-- links: main serial chain -->
  <link name="base_link">
    <visual>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur5/visual/base.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="0 0 3.141592653589793" xyz="0 0 0.046"/>
      <geometry>
        <cylinder length="0.09" radius="0.08"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="4.0"/>
      <origin rpy="0 0 0" xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.00443333156" ixy="0.0" ixz="0.0" iyy="0.00443333156" iyz="0.0" izz="0.0072"/>
    </inertial>
  </link>
  <link name="shoulder_link">
    <visual>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur5/visual/shoulder.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="0 0 3.141592653589793" xyz="0 0 0"/>
      <geometry>
        <cylinder length="0.135" radius="0.065"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="3.7"/>
      <origin rpy="0 0 0" xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.010267495893" ixy="0.0" ixz="0.0" iyy="0.010267495893" iyz="0.0" izz="0.00666"/>
    </inertial>
  </link>
  <link name="upper_arm_link">
    <visual>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur5/visual/upperarm.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 -1.5707963267948966 0" xyz="0 0 0"/>
      <geometry>
        <cylinder length="0.135" radius="0.06"/>
      </geometry>
    </collision>
    <collision>
      <origin rpy="0 0 -1.5707963267948966" xyz="0 0 0.21"/>
      <geometry>
        <cylinder length="0.3" radius="0.06"/>
      </geometry>
    </collision>
    <collision>
      <origin rpy="1.5707963267948966 -1.5707963267948966 0" xyz="0 0 0.43"/>
      <geometry>
        <cylinder length="0.135" radius="0.06"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="8.393"/>
      <origin rpy="0 0 0" xyz="0.0 0.0 0.2125"/>
      <inertia ixx="0.133885781862" ixy="0.0" ixz="0.0" iyy="0.133885781862" iyz="0.0" izz="0.0151074"/>
    </inertial>
  </link>
  <link name="forearm_link">
    <visual>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur5/visual/forearm.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 -1.5707963267948966 0" xyz="0 0 0"/>
      <geometry>
        <cylinder length="0.11" radius="0.06"/>
      </geometry>
    </collision>
    <collision>
      <origin rpy="0 0 -1.5707963267948966" xyz="0 0 0.2"/>
      <geometry>
        <cylinder length="0.28" radius="0.05"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="2.275"/>
      <origin rpy="0 0 0" xyz="0.0 0.0 0.196"/>
      <inertia ixx="0.0311796208615" ixy="0.0" ixz="0.0" iyy="0.0311796208615" iyz="0.0" izz="0.004095"/>
    </inertial>
  </link>
  <link name="wrist_1_link">
    <visual>
      <!-- TODO: Move this to a parameter -->
      <geometry>
        <mesh filename="package://ur_description/meshes/ur5/visual/wrist1.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 -1.5707963267948966 0" xyz="0 0.01 0"/>
      <geometry>
        <cylinder length="0.14" radius="0.042"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="1.219"/>
      <origin rpy="0 0 0" xyz="0.0 0.127 0.0"/>
      <inertia ixx="0.00255989897604" ixy="0.0" ixz="0.0" iyy="0.00255989897604" iyz="0.0" izz="0.0021942"/>
    </inertial>
  </link>
  <link name="wrist_2_link">
    <visual>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur5/visual/wrist2.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <geometry>
        <cylinder length="0.11" radius="0.04"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="1.219"/>
      <origin rpy="0 0 0" xyz="0.0 0.0 0.1"/>
      <inertia ixx="0.00255989897604" ixy="0.0" ixz="0.0" iyy="0.00255989897604" iyz="0.0" izz="0.0021942"/>
    </inertial>
  </link>
  <link name="wrist_3_link">
    <visual>
      <geometry>
        <mesh filename="package://ur_description/meshes/ur5/visual/wrist3.dae"/>
      </geometry>
      <material name="LightGrey">
        <color rgba="0.7 0.7 0.7 1.0"/>
      </material>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 -1.5707963267948966 0" xyz="0 0.02 0"/>
      <geometry>
        <cylinder length="0.16" radius="0.04"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="0.1879"/>
      <origin rpy="1.57079632679 0 0" xyz="0.0 0.0771 0.0"/>
      <inertia ixx="9.89041005217e-05" ixy="0.0" ixz="0.0" iyy="9.89041005217e-05" iyz="0.0" izz="0.0001321171875"/>
    </inertial>
  </link>
  <!-- joints: main serial chain -->
  <joint name="shoulder_pan_joint" type="revolute">
    <parent link="base_link"/>
    <child link="shoulder_link"/>
    <origin rpy="0.0 0.0 0.0" xyz="0.0 0.0 0.163"/>
    <axis xyz="0 0 1"/>
    <limit effort="150.0" lower="-6.28318530718" upper="6.28318530718" velocity="3.14"/>
    <dynamics damping="0.0" friction="0.0"/>
  </joint>
  <joint name="shoulder_lift_joint" type="revolute">
    <parent link="shoulder_link"/>
    <child link="upper_arm_link"/>
    <origin rpy="0.0 1.57079632679 0.0" xyz="0.0 0.138 0.0"/>
    <axis xyz="0 1 0"/>
    <limit effort="150.0" lower="-6.28318530718" upper="6.28318530718" velocity="3.14"/>
    <dynamics damping="0.0" friction="0.0"/>
  </joint>
  <joint name="elbow_joint" type="revolute">
    <parent link="upper_arm_link"/>
    <child link="forearm_link"/>
    <origin rpy="0.0 0.0 0.0" xyz="0.0 -0.131 0.425"/>
    <axis xyz="0 1 0"/>
    <limit effort="150.0" lower="-3.14159265359" upper="3.14159265359" velocity="3.14"/>
    <dynamics damping="0.0" friction="0.0"/>
  </joint>
  <joint name="wrist_1_joint" type="revolute">
    <parent link="forearm_link"/>
    <child link="wrist_1_link"/>
    <origin rpy="0.0 1.57079632679 0.0" xyz="0.0 0.0 0.392"/>
    <axis xyz="0 1 0"/>
    <limit effort="28.0" lower="-6.28318530718" upper="6.28318530718" velocity="6.28"/>
    <dynamics damping="0.0" friction="0.0"/>
  </joint>
  <joint name="wrist_2_joint" type="revolute">
    <parent link="wrist_1_link"/>
    <child link="wrist_2_link"/>
    <origin rpy="0.0 0.0 0.0" xyz="0.0 0.127 0.0"/>
    <axis xyz="0 0 1"/>
    <limit effort="28.0" lower="-6.28318530718" upper="6.28318530718" velocity="6.28"/>
    <dynamics damping="0.0" friction="0.0"/>
  </joint>
  <joint name="wrist_3_joint" type="revolute">
    <parent link="wrist_2_link"/>
    <child link="wrist_3_link"/>
    <origin rpy="0.0 0.0 0.0" xyz="0.0 0.0 0.1"/>
    <axis xyz="0 1 0"/>
    <limit effort="28.0" lower="-6.28318530718" upper="6.28318530718" velocity="6.28"/>
    <dynamics damping="0.0" friction="0.0"/>
  </joint>
  <!-- ROS-Industrial 'flange' frame: attachment point for EEF models -->
  <link name="flange"/>
  <joint name="wrist_3-flange" type="fixed">
    <parent link="wrist_3_link"/>
    <child link="flange"/>
    <origin rpy="0 -3.14 -1.5707963267948966" xyz="0 0.09 0"/>
  </joint>
  <!-- ROS-Industrial 'tool0' frame: all-zeros tool frame -->
  <link name="tool0"/>
  <joint name="flange-tool0" type="fixed">
    <!-- default toolframe: X+ left, Y+ up, Z+ front -->
    <origin rpy="1.5707963267948966 0 1.5707963267948966" xyz="0 0 0"/>
    <parent link="flange"/>
    <child link="tool0"/>
  </joint>
  <joint name="robotiq_85_base_joint" type="fixed">
    <parent link="flange"/>
    <child link="robotiq_85_base_link"/>
  </joint>

  <link name="robotiq_85_base_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_base_link.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 -1.5707963267948966 0" xyz="0.05 0 0"/>
      <geometry>
        <sphere length="0.16" radius="0.04"/>
      </geometry>
    </collision>
    <inertial>
      <mass value="0.636951" />
      <origin xyz="0.0 0.0 0.0" />
      <inertia ixx = "0.000380" ixy = "0.000000" ixz = "0.000000"
           iyx = "0.000000" iyy = "0.001110" iyz = "0.000000"
           izx = "0.000000" izy = "0.000000" izz = "0.001171" />
    </inertial>
  </link>

  <joint name="robotiq_85_left_knuckle_joint" type="revolute">
    <parent link="robotiq_85_base_link"/>
    <child link="robotiq_85_left_knuckle_link"/>
    <axis xyz="0 0 1"/>
    <origin rpy="3.14159265359 0.0 0.0" xyz="0.05490451627 0.03060114443 0.0"/>
    <limit effort="1000" lower="0.0" upper="0.80285" velocity="0.5"/>
  </joint>
  <joint name="robotiq_85_right_knuckle_joint" type="continuous">
    <parent link="robotiq_85_base_link"/>
    <child link="robotiq_85_right_knuckle_link"/>
    <axis xyz="0 0 1"/>
    <origin rpy="0.0 0.0 0.0" xyz="0.05490451627 -0.03060114443 0.0"/>
    <limit effort="1000" lower="-3.14" upper="3.14" velocity="100.0"/>
    <mimic joint="robotiq_85_left_knuckle_joint"/>
  </joint>
  <link name="robotiq_85_left_knuckle_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_knuckle_link.dae"/>
      </geometry>
    </visual>
    <inertial>
      <mass value="0.018491"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000009" ixy="-0.000001" ixz="0.000000" iyy="0.000001" iyz="0.000000" izz="0.000010"/>
    </inertial>
  </link>
  <link name="robotiq_85_right_knuckle_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_knuckle_link.dae"/>
      </geometry>
    </visual>
    <inertial>
      <mass value="0.018491"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000009" ixy="-0.000001" ixz="0.000000" iyy="0.000001" iyz="0.000000" izz="0.000010"/>
    </inertial>
  </link>

  <joint name="robotiq_85_left_finger_joint" type="fixed">
    <parent link="robotiq_85_left_knuckle_link"/>
    <child link="robotiq_85_left_finger_link"/>
    <origin rpy="0 0 0" xyz="-0.00408552455 -0.03148604435 0.0"/>
  </joint>
  <joint name="robotiq_85_right_finger_joint" type="fixed">
    <parent link="robotiq_85_right_knuckle_link"/>
    <child link="robotiq_85_right_finger_link"/>
    <origin rpy="0 0 0" xyz="-0.00408552455 -0.03148604435 0.0"/>
  </joint>
  <link name="robotiq_85_left_finger_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_finger_link.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="0 0 -0.14" xyz="0.025 -0.005 0"/>
      <geometry>
        <box size="0.06 0.015 0.03" />
      </geometry>
    </collision>
    <inertial>
      <mass value="0.027309"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000003" ixy="-0.000002" ixz="0.000000" iyy="0.000021" iyz="0.000000" izz="0.000020"/>
    </inertial>
  </link>
  <link name="robotiq_85_right_finger_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_finger_link.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="0 0 -0.14" xyz="0.025 -0.005 0"/>
      <geometry>
        <box size="0.06 0.015 0.03" />
      </geometry>
    </collision>
    <inertial>
      <mass value="0.027309"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000003" ixy="-0.000002" ixz="0.000000" iyy="0.000021" iyz="0.000000" izz="0.000020"/>
    </inertial>
  </link>

  <joint name="robotiq_85_left_inner_knuckle_joint" type="continuous">
    <parent link="robotiq_85_base_link"/>
    <child link="robotiq_85_left_inner_knuckle_link"/>
    <axis xyz="0 0 1"/>
    <origin rpy="3.14159265359 0.0 0.0" xyz="0.06142 0.0127 0"/>
    <limit effort="0.1" lower="-3.14" upper="3.14" velocity="100.0"/>
    <mimic joint="robotiq_85_left_knuckle_joint" offset="0"/>
  </joint>
  <joint name="robotiq_85_right_inner_knuckle_joint" type="continuous">
    <parent link="robotiq_85_base_link"/>
    <child link="robotiq_85_right_inner_knuckle_link"/>
    <axis xyz="0 0 1"/>
    <origin rpy="0 0 0" xyz="0.06142 -0.0127 0"/>
    <limit effort="0.1" lower="-3.14" upper="3.14" velocity="100.0"/>
    <mimic joint="robotiq_85_left_knuckle_joint" offset="0"/>
  </joint>
  <link name="robotiq_85_left_inner_knuckle_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_inner_knuckle_link.dae"/>
      </geometry>
    </visual>
    <inertial>
      <mass value="0.029951"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000039" ixy="0.000000" ixz="0.000000" iyy="0.000005" iyz="0.000000" izz="0.000035"/>
    </inertial>
  </link>
  <link name="robotiq_85_right_inner_knuckle_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_inner_knuckle_link.dae"/>
      </geometry>
    </visual>
    <inertial>
      <mass value="0.029951"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000039" ixy="0.000000" ixz="0.000000" iyy="0.000005" iyz="0.000000" izz="0.000035"/>
    </inertial>
  </link>

  <joint name="robotiq_85_left_finger_tip_joint" type="continuous">
    <parent link="robotiq_85_left_inner_knuckle_link"/>
    <child link="robotiq_85_left_finger_tip_link"/>
    <axis xyz="0 0 1"/>
    <origin rpy="0.0 0.0 0.0" xyz="0.04303959807 -0.03759940821 0.0"/>
    <limit effort="0.1" lower="-3.14" upper="3.14" velocity="100.0"/>
    <mimic joint="robotiq_85_left_knuckle_joint" multiplier="-1"/>
  </joint>
  <joint name="robotiq_85_right_finger_tip_joint" type="continuous">
    <parent link="robotiq_85_right_inner_knuckle_link"/>
    <child link="robotiq_85_right_finger_tip_link"/>
    <axis xyz="0 0 1"/>
    <origin rpy="0.0 0.0 0.0" xyz="0.04303959807 -0.03759940821  0.0"/>
    <limit effort="0.1" lower="-3.14" upper="3.14" velocity="100.0"/>
    <mimic joint="robotiq_85_left_knuckle_joint" multiplier="-1"/>
  </joint>
  <link name="robotiq_85_left_finger_tip_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_finger_tip_link.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 -1.5707963267948966 0" xyz="0.02 0 0"/>
      <geometry>
        <box size="0.025 0.045 0.01" />
      </geometry>
    </collision>
    <inertial>
      <mass value="0.019555"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000002" ixy="0.000000" ixz="0.000000" iyy="0.000005" iyz="0.000000" izz="0.000006"/>
    </inertial>
  </link>
  <link name="robotiq_85_right_finger_tip_link">
    <visual>
      <geometry>
        <mesh filename="package://robotiq_85_description/meshes/visual/robotiq_85_finger_tip_link.dae"/>
      </geometry>
    </visual>
    <collision>
      <origin rpy="1.5707963267948966 -1.5707963267948966 0" xyz="0.02 0 0"/>
      <geometry>
        <box size="0.025 0.045 0.01" />
      </geometry>
    </collision>
    <inertial>
      <mass value="0.019555"/>
      <origin xyz="0.0 0.0 0.0"/>
      <inertia ixx="0.000002" ixy="0.000000" ixz="0.000000" iyy="0.000005" iyz="0.000000" izz="0.000006"/>
    </inertial>
  </link>
</robot>`;

export const quori = `<?xml version="1.0" ?>
<!-- =================================================================================== -->
<!-- |    This document was autogenerated by xacro from quori.xacro                    | -->
<!-- |    EDITING THIS FILE BY HAND IS NOT RECOMMENDED                                 | -->
<!-- =================================================================================== -->
<robot name="quori">
  <link name="quori/base_link">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0.23"/>
      <mass value="2"/>
      <inertia ixx="0.052" ixy="0" ixz="0" iyy="0.052" iyz="0" izz="0.031"/>
    </inertial>
    <visual>
      <origin rpy="0 0 -1.57079632679" xyz="0.02 0 -0.2007174"/>
      <geometry>
        <mesh filename="package://quori_description/meshes/180915_Lower_Torso.dae"/>
      </geometry>
    </visual>
  </link>
  <link name="quori/body_upper">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 -0.01"/>
      <mass value="26.75"/>
      <inertia ixx="2.5" ixy="0" ixz="0" iyy="2.5" iyz="0" izz="0.134"/>
    </inertial>
    <visual>
      <origin rpy="0 0 -1.57079632679" xyz="0.02 0 -0.5476974"/>
      <geometry>
        <mesh filename="package://quori_description/meshes/0917_Upper_Torso+Waist.dae"/>
      </geometry>
    </visual>
  </link>
  <joint name="waist_pitch" type="revolute">
    <origin rpy="0 0 0" xyz="0 0 0.34798"/>
    <parent link="quori/base_link"/>
    <child link="quori/body_upper"/>
    <axis xyz="0 -1 0"/>
    <limit effort="1" lower="-0.47123889803846897" upper="0.2111848394913139" velocity="1"/>
  </joint>
  <link name="quori/r_shoulder">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <mass value="0.0"/>
      <inertia ixx="0.0" ixy="0" ixz="0" iyy="0.0" iyz="0" izz="0.0"/>
    </inertial>
  </link>
  <joint name="r_shoulder_pitch" type="revolute">
    <origin rpy="0 0 0" xyz="0.015 -0.16403066 0.43021758"/>
    <parent link="quori/body_upper"/>
    <child link="quori/r_shoulder"/>
    <axis xyz="0 -1 0"/>
    <limit effort="1" lower="-2.4" upper="2.4" velocity="1"/>
  </joint>
  <link name="quori/r_arm_upper">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <mass value="0.00"/>
      <inertia ixx="0.0" ixy="0" ixz="0" iyy="0.0" iyz="0" izz="0.0"/>
    </inertial>
    <visual>
      <origin rpy="-1.57079632679 0 0" xyz="0.165 -0.9765 -0.137"/>
      <geometry>
        <mesh filename="package://quori_description/meshes/0917_Upper_Arm+gear_right.dae"/>
      </geometry>
    </visual>
  </link>
  <joint name="r_shoulder_roll" type="revolute">
    <origin rpy="0 0 0" xyz="0 0 0"/>
    <parent link="quori/r_shoulder"/>
    <child link="quori/r_arm_upper"/>
    <axis xyz="-1 0 0"/>
    <limit effort="1" lower="-1.1" upper="1.1" velocity="1"/>
  </joint>
  <link name="quori/r_arm_upper2lower">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0.3"/>
      <mass value="0.19"/>
      <inertia ixx="0.006" ixy="0" ixz="0" iyy="0.006" iyz="0" izz="0.0"/>
    </inertial>
    <visual>
      <origin rpy="-1.57079632679 0 0" xyz="0 -0.13 0"/>
      <geometry>
        <cylinder length="0.08" radius="0.015"/>
      </geometry>
      <material name="white"/>
    </visual>
  </link>
  <joint name="r_arm_upper2lower_j" type="fixed">
    <parent link="quori/r_arm_upper"/>
    <child link="quori/r_arm_upper2lower"/>
  </joint>
  <link name="quori/r_arm_lower">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <mass value="0.00"/>
      <inertia ixx="0.0" ixy="0" ixz="0" iyy="0.0" iyz="0" izz="0.0"/>
    </inertial>
    <visual>
      <origin rpy="1.570759635 1.570759635 0" xyz="0 0 0"/>
      <geometry>
        <mesh filename="package://quori_description/meshes/0917_Lower_Arm_right.dae"/>
      </geometry>
    </visual>
  </link>
  <joint name="r_elbow_pitch" type="fixed">
    <origin rpy="0 0 0" xyz="0 -0.15 0"/>
    <parent link="quori/r_arm_upper"/>
    <child link="quori/r_arm_lower"/>
  </joint>
  <link name="quori/l_shoulder">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <mass value="0.0"/>
      <inertia ixx="0.0" ixy="0" ixz="0" iyy="0.0" iyz="0" izz="0.0"/>
    </inertial>
  </link>
  <joint name="l_shoulder_pitch" type="revolute">
    <origin rpy="0 0 0" xyz="0.015 0.16403066 0.43021758"/>
    <parent link="quori/body_upper"/>
    <child link="quori/l_shoulder"/>
    <axis xyz="0 -1 0"/>
    <limit effort="1" lower="-2.4" upper="2.4" velocity="1"/>
  </joint>
  <link name="quori/l_arm_upper">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <mass value="0.00"/>
      <inertia ixx="0.0" ixy="0" ixz="0" iyy="0.0" iyz="0" izz="0.0"/>
    </inertial>
    <visual>
      <origin rpy="-1.57079632679 0 -3.14" xyz="0.165 0.9765 -0.137"/>
      <geometry>
        <mesh filename="package://quori_description/meshes/0917_Upper_Arm+gear_left.dae"/>
      </geometry>
    </visual>
  </link>
  <joint name="l_shoulder_roll" type="revolute">
    <origin rpy="0 0 0" xyz="0 0 0"/>
    <parent link="quori/l_shoulder"/>
    <child link="quori/l_arm_upper"/>
    <axis xyz="1 0 0"/>
    <limit effort="1" lower="-1.1" upper="1.1" velocity="1"/>
  </joint>
  <link name="quori/l_arm_upper2lower">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0.3"/>
      <mass value="0.19"/>
      <inertia ixx="0.006" ixy="0" ixz="0" iyy="0.006" iyz="0" izz="0.0"/>
    </inertial>
    <visual>
      <origin rpy="-1.57079632679 0 0" xyz="0 0.13 0"/>
      <geometry>
        <cylinder length="0.08" radius="0.015"/>
      </geometry>
      <material name="white"/>
    </visual>
  </link>
  <joint name="l_arm_upper2lower_j" type="fixed">
    <parent link="quori/l_arm_upper"/>
    <child link="quori/l_arm_upper2lower"/>
  </joint>
  <link name="quori/l_arm_lower">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <mass value="0.00"/>
      <inertia ixx="0.0" ixy="0" ixz="0" iyy="0.0" iyz="0" izz="0.0"/>
    </inertial>
    <visual>
      <origin rpy="-1.570759635 -1.570759635 0" xyz="0 0 0"/>
      <geometry>
        <mesh filename="package://quori_description/meshes/0917_Lower_Arm_left.dae"/>
      </geometry>
    </visual>
  </link>
  <joint name="l_elbow_pitch" type="fixed">
    <origin rpy="0 0 0" xyz="0 0.15 0"/>
    <parent link="quori/l_arm_upper"/>
    <child link="quori/l_arm_lower"/>
  </joint>
  <link name="quori/head">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <mass value="1.9"/>
      <inertia ixx="0.008" ixy="0" ixz="0" iyy="0.0056" iyz="0" izz="0.0056"/>
    </inertial>
    <visual>
      <origin xyz="0 0 0.085"/>
      <geometry>
        <sphere radius="0.11"/>
      </geometry>
      <material name="white"/>
    </visual>
    <visual>
      <origin rpy="0 0 -1.57079632679" xyz="0.01 0 -1.11"/>
      <geometry>
        <mesh filename="package://quori_description/meshes/0917_Helmet_Duripod.dae"/>
      </geometry>
    </visual>
  </link>
  <joint name="neck" type="fixed">
    <origin rpy="0 0 0" xyz="0 0 0.554"/>
    <parent link="quori/body_upper"/>
    <child link="quori/head"/>
  </joint>
  <joint name="head_camera_optical_joint" type="fixed">
    <origin rpy="-1.57079632679 0 -1.57079632679" xyz="0 0 0"/>
    <parent link="quori/head_camera"/>
    <child link="quori/head_camera_optical"/>
  </joint>
  <link name="quori/head_camera_optical">
  </link>
  <link name="quori/head_camera">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <mass value="0.3"/>
      <inertia ixx="0.0004" ixy="0" ixz="0" iyy="0.0001" iyz="0" izz="0.0004"/>
    </inertial>
    <visual>
      <geometry>
        <box size="0.04 0.11 0.04"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 -0"/>
      <material name="black"/>
    </visual>
  </link>
  <joint name="camera_pitch" type="fixed">
    <origin rpy="0 0 0" xyz="0.055 0 0.21"/>
    <parent link="quori/head"/>
    <child link="quori/head_camera"/>
  </joint>
  <link name="quori/head_mic">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <mass value="0.05"/>
      <inertia ixx="0.0" ixy="0" ixz="0" iyy="0.0" iyz="0" izz="0.0"/>
    </inertial>
    <visual>
      <geometry>
        <cylinder length="0.002" radius="0.03"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 -0"/>
      <material name="blue"/>
    </visual>
  </link>
  <joint name="mic_array" type="fixed">
    <origin rpy="0 -.3 0" xyz="-0.008 0 0.218"/>
    <parent link="quori/head"/>
    <child link="quori/head_mic"/>
  </joint>
  <material name="ramsis/base_link_material">
    <color rgba="0 0 0 1"/>
  </material>
  <material name="ramsis/laser_scanner_material">
    <color rgba="0.3 0.3 0.3 1"/>
  </material>
  <link name="ramsis/base_link_diff">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0.1013587"/>
      <mass value="9.8"/>
      <inertia ixx="0.176" ixy="0" ixz="0" iyy="0.176" iyz="0" izz="0.285"/>
    </inertial>
    <visual>
      <origin rpy="0 0 0" xyz="0 0 0.1013587"/>
      <geometry>
        <cylinder length="0.2027174" radius="0.2413"/>
      </geometry>
      <material name="ramsis/base_link_material"/>
    </visual>
  </link>
  <link name="ramsis/base_laser_scanner">
    <inertial>
      <mass value="0.17"/>
      <inertia ixx="0.0001" ixy="0" ixz="0" iyy="0.0001" iyz="0" izz="0.0001"/>
    </inertial>
    <visual>
      <geometry>
        <cylinder length="0.025" radius="0.05"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 -0"/>
      <material name="ramsis/laser_scanner_material"/>
    </visual>
  </link>
  <joint name="laser_scanner_joint" type="fixed">
    <origin rpy="0 0.0 -1.5707" xyz="0.152 0 0.156"/>
    <parent link="ramsis/base_link_diff"/>
    <child link="ramsis/base_laser_scanner"/>
  </joint>
  <link name="ramsis/turret_link">
  </link>
  <link name="ramsis/base_link">
  </link>
  <link name="ramsis/l_wheel_link">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <mass value="0.0"/>
      <inertia ixx="0.0" ixy="0" ixz="0" iyy="0.0" iyz="0" izz="0.0"/>
    </inertial>
  </link>
  <link name="ramsis/r_wheel_link">
    <inertial>
      <origin rpy="0 0 0" xyz="0 0 0"/>
      <mass value="0.0"/>
      <inertia ixx="0.0" ixy="0" ixz="0" iyy="0.0" iyz="0" izz="0.0"/>
    </inertial>
  </link>
  <joint name="ramsis/wheel_axle_joint" type="fixed">
    <origin xyz="0.1 0 -0.075"/>
    <parent link="ramsis/wheel_axle"/>
    <child link="ramsis/base_link_diff"/>
  </joint>
  <joint name="turret2base" type="fixed">
    <origin xyz="0 0 -0.2027174"/>
    <parent link="ramsis/turret_link"/>
    <child link="ramsis/base_link"/>
  </joint>
  <link name="ramsis/wheel_axle">
  </link>
  <joint name="l_wheel" type="continuous">
    <origin rpy="0 0 0" xyz="0 0.12284075 0"/>
    <parent link="ramsis/wheel_axle"/>
    <child link="ramsis/l_wheel_link"/>
    <axis xyz="0 1 0"/>
    <limit effort="1" velocity="0.5"/>
  </joint>
  <joint name="r_wheel" type="continuous">
    <origin rpy="0 0 0" xyz="0 -0.12284075 0"/>
    <parent link="ramsis/wheel_axle"/>
    <child link="ramsis/r_wheel_link"/>
    <axis xyz="0 1 0"/>
    <limit effort="1" velocity="0.5"/>
  </joint>
  <joint name="turret" type="continuous">
    <origin rpy="0 0 0" xyz="0 0 0.2027174"/>
    <parent link="ramsis/base_link_diff"/>
    <child link="ramsis/turret_link"/>
    <axis xyz="0 0 1"/>
    <limit effort="1" velocity="3"/>
  </joint>
  <quori_kinematics/>
  <ramsis_kinematics/>
  <!-- Join the quori robot to the ramsis robot's turret joint -->
  <joint name="ramsis_quori_connector" type="fixed">
    <parent link="ramsis/turret_link"/>
    <child link="quori/base_link"/>
  </joint>
</robot>`;

export const pepper = `<?xml version="1.0" ?>
<robot name="pepper">
  <link name="base_link"/>
  <joint name="HeadYaw" type="revolute">
    <parent link="torso"/>
    <child link="Neck"/>
    <origin rpy="0 0 0" xyz="-0.038 0 0.3089"/>
    <axis xyz="0 0 1.0"/>
    <limit effort="5.428" lower="-2.08567" upper="2.08567" velocity="7.33998"/>
  </joint>
  <link name="Neck">
    <inertial>
      <mass value="0.27391"/>
      <inertia ixx="0.000343501" ixy="0" ixz="-1.88563e-05" iyy="0.000493898" iyz="2.09863e-06" izz="0.000215252"/>
      <origin rpy="0 0 0" xyz="-0.00207 0 -0.02636"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/HeadYaw.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
  </link>

  <joint name="HeadPitch" type="revolute">
    <parent link="Neck"/>
    <child link="Head"/>
    <origin rpy="0 0 0" xyz="0 0 0"/>
    <axis xyz="0 1.0 0"/>
    <limit effort="2.666" lower="-0.706858" upper="0.43" velocity="9.22756"/>
  </joint>
  <link name="Head">
    <inertial>
      <mass value="1.51893"/>
      <inertia ixx="0.00597209" ixy="0" ixz="0.000125138" iyy="0.0059054" iyz="4.3428e-07" izz="0.00570374"/>
      <origin rpy="0 0 0" xyz="0.00312 0 0.11152"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/HeadPitch.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>

    <collision>
    <origin rpy="0 0 0" xyz="0 0 0.1"/>
      <geometry>
        <sphere radius = "0.12"/>
      </geometry>
      
    </collision>
    
  </link>
  <joint name="HipRoll" type="revolute">
    <parent link="Hip"/>
    <child link="torso"/>
    <origin rpy="0 0 0" xyz="0 0 0.079"/>
    <axis xyz="-1.0 0 0"/>
    <limit effort="10.1884" lower="-0.514872" upper="0.514872" velocity="2.27032"/>
  </joint>
  <link name="Hip">
    <inertial>
      <mass value="1.02338"/>
      <inertia ixx="0.00502422" ixy="0" ixz="-2.54911e-05" iyy="0.00640971" iyz="0.000159449" izz="0.00441082"/>
      <origin rpy="0 0 0" xyz="0.00032 0 -0.06039"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/HipRoll.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0.079"/>
    </visual>

    <collision>
    <origin rpy="0 0 0" xyz="0 0 0.22"/>
      <geometry>
        <cylinder length = "0.3" radius = "0.17"/>
      </geometry>
      
    </collision>
   
  </link>
  <joint name="HipPitch" type="revolute">
    <parent link="Pelvis"/>
    <child link="Hip"/>
    <origin rpy="0 0 0" xyz="0 0 0.268"/>
    <axis xyz="0 -1.0 0"/>
    <limit effort="19.787" lower="-1.03847" upper="1.03847" velocity="2.93276"/>
  </joint>
  <link name="Pelvis">
    <inertial>
      <mass value="2.45917"/>
      <inertia ixx="0.034351" ixy="0" ixz="0.000223034" iyy="0.0303122" iyz="-8.37542e-05" izz="0.0143771"/>
      <origin rpy="0 0 0" xyz="0.00237 0 -0.09654"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/HipPitch.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0.268"/>
    </visual>

    <collision>
    <origin rpy="0 0 0" xyz="0 0 0.15"/>
      <geometry>
        <cylinder length = "0.35" radius = "0.13"/>
      </geometry>
      
    </collision>
   
  </link>
  <joint name="KneePitch" type="revolute">
    <parent link="Tibia"/>
    <child link="Pelvis"/>
    <origin rpy="0 0 0" xyz="0 0 0"/>
    <axis xyz="0 -1.0 0"/>
    <limit effort="27.702" lower="-0.514872" upper="0.514872" velocity="2.93276"/>
  </joint>
  <link name="Tibia">
    <inertial>
      <mass value="11.6015"/>
      <inertia ixx="0.129229" ixy="-0.000401943" ixz="0.00048556" iyy="0.122839" iyz="-1.01666e-08" izz="0.108168"/>
      <origin rpy="0 0 0" xyz="0.00220451 0 -0.185729"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/KneePitch.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>

     <collision>
    <origin rpy="0 0 0" xyz="0 0 -0.2"/>
      <geometry>
        <cylinder length = "0.27" radius = "0.26"/>
      </geometry>
      
    </collision>
   
  </link>

  <link name="torso">
    <inertial>
      <mass value="3.99533"/>
      <inertia ixx="0.0452761" ixy="0" ixz="0.00499091" iyy="0.0432702" iyz="-0.000266886" izz="0.0258881"/>
      <origin rpy="0 0 0" xyz="0.00322 0 -0.01029"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/Torso.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="2e-05 0 0.139"/>
    </visual>

   
    
  </link>
  <joint name="LShoulderPitch" type="revolute">
    <parent link="torso"/>
    <child link="LShoulder"/>
    <origin rpy="0 0 0" xyz="-0.057 0.14974 0.22582"/>
    <axis xyz="0 1.0 0"/>
    <limit effort="5.428" lower="-2.08567" upper="2.08567" velocity="7.33998"/>
  </joint>
  <link name="LShoulder">
    <inertial>
      <mass value="0.3125"/>
      <inertia ixx="0.000361198" ixy="-1.98347e-06" ixz="6.35907e-07" iyy="0.000137229" iyz="-5.68878e-06" izz="0.000399194"/>
      <origin rpy="0 0 0" xyz="0.00018 -0.01856 0.00099"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LShoulderPitch.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>

   
    
  </link>
  <joint name="LShoulderRoll" type="revolute">
    <parent link="LShoulder"/>
    <child link="LBicep"/>
    <origin rpy="0 0 0" xyz="0 0 0"/>
    <axis xyz="0 0 1.0"/>
    <limit effort="2.666" lower="0.00872665" upper="1.56207" velocity="9.22756"/>
  </joint>
  <link name="LBicep">
    <inertial>
      <mass value="0.50527"/>
      <inertia ixx="0.000500872" ixy="-3.55918e-05" ixz="8.51263e-05" iyy="0.00126284" iyz="9.06813e-06" izz="0.00115718"/>
      <origin rpy="0 0 0" xyz="0.08151 0.01284 -0.01017"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LShoulderRoll.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>

   
   
  </link>
  <joint name="LElbowYaw" type="revolute">
    <parent link="LBicep"/>
    <child link="LElbow"/>
    <origin rpy="0 -0.157079 0" xyz="0.1812 0.015 0.00013"/>
    <axis xyz="1.0 0 0"/>
    <limit effort="5.428" lower="-2.08567" upper="2.08567" velocity="7.33998"/>
  </joint>
  <link name="LElbow">
    <inertial>
      <mass value="0.27495"/>
      <inertia ixx="0.000122971" ixy="9.86024e-07" ixz="-2.55838e-05" iyy="0.000331766" iyz="-1.98925e-06" izz="0.000303047"/>
      <origin rpy="0 0 0" xyz="-0.02297 -0.00019 0.00119"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LElbowYaw.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>

    <collision>
    <origin rpy="0. 0.2 0" xyz="-0.08 00 0.02"/>
      <geometry>
        <box size = "0.1 0.07 0.07"/>
      </geometry>
      
    </collision>
    
    
  </link>
  <joint name="LElbowRoll" type="revolute">
    <parent link="LElbow"/>
    <child link="LForeArm"/>
    <origin rpy="0 0 0" xyz="0 0 0"/>
    <axis xyz="0 0 1.0"/>
    <limit effort="2.666" lower="-1.56207" upper="-0.00872665" velocity="9.22756"/>
  </joint>
  <link name="LForeArm">
    <inertial>
      <mass value="0.16579"/>
      <inertia ixx="0.00156513" ixy="1.47517e-05" ixz="-6.05746e-05" iyy="0.00173219" iyz="-1.7619e-07" izz="0.000273081"/>
      <origin rpy="0 0 0" xyz="0.0593 0.00271 -0.01014"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LElbowRoll.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
    <collision>
    <origin rpy="0 0 0" xyz="0.15 0 0"/>
      <geometry>
        <box size = "0.23 0.07 0.07"/>
      </geometry>
      
    </collision>
  </link>
  <joint name="LWristYaw" type="revolute">
    <parent link="LForeArm"/>
    <child link="l_wrist"/>
    <origin rpy="0 0 0" xyz="0.15 0 0"/>
    <axis xyz="1.0 0 0"/>
    <limit effort="0.2014" lower="-1.82387" upper="1.82387" velocity="17.3835"/>
  </joint>
  <link name="l_wrist">
    <inertial>
      <mass value="0.27555"/>
      <inertia ixx="0.000151643" ixy="1.06629e-05" ixz="2.89509e-06" iyy="0.000431099" iyz="-3.13715e-06" izz="0.000456172"/>
      <origin rpy="0 0 0" xyz="0.03536 -0.00072 -0.00207"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LWristYaw.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="LHand" type="revolute">
    <parent link="l_wrist"/>
    <child link="l_gripper"/>
    <origin rpy="0 0 0" xyz="0.025 0 0"/>
    <axis xyz="1.0 0 0"/>
    <limit effort="0.144" lower="0" upper="1" velocity="12.56"/>
  </joint>
  <link name="l_gripper">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
  </link>
  <joint name="RShoulderPitch" type="revolute">
    <parent link="torso"/>
    <child link="RShoulder"/>
    <origin rpy="0 0 0" xyz="-0.057 -0.14974 0.22582"/>
    <axis xyz="0 1.0 0"/>
    <limit effort="5.428" lower="-2.08567" upper="2.08567" velocity="7.33998"/>
  </joint>
  <link name="RShoulder">
    <inertial>
      <mass value="0.3125"/>
      <inertia ixx="0.000361198" ixy="1.98347e-06" ixz="6.35907e-07" iyy="0.000137229" iyz="5.68878e-06" izz="0.000399194"/>
      <origin rpy="0 0 0" xyz="0.00018 0.01856 0.00099"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RShoulderPitch.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RShoulderRoll" type="revolute">
    <parent link="RShoulder"/>
    <child link="RBicep"/>
    <origin rpy="0 0 0" xyz="0 0 0"/>
    <axis xyz="0 0 1.0"/>
    <limit effort="2.666" lower="-1.56207" upper="-0.00872665" velocity="9.22756"/>
  </joint>
  <link name="RBicep">
    <inertial>
      <mass value="0.50527"/>
      <inertia ixx="0.000500872" ixy="3.55918e-05" ixz="8.51263e-05" iyy="0.00126284" iyz="-9.06813e-06" izz="0.00115718"/>
      <origin rpy="0 0 0" xyz="0.08151 -0.01284 -0.01017"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RShoulderRoll.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RElbowYaw" type="revolute">
    <parent link="RBicep"/>
    <child link="RElbow"/>
    <origin rpy="0 -0.157079 0" xyz="0.1812 -0.015 0.00013"/>
    <axis xyz="1.0 0 0"/>
    <limit effort="5.428" lower="-2.08567" upper="2.08567" velocity="7.33998"/>
  </joint>
  <link name="RElbow">
    <inertial>
      <mass value="0.27495"/>
      <inertia ixx="0.000122971" ixy="-9.86024e-07" ixz="-2.55838e-05" iyy="0.000331766" iyz="1.98925e-06" izz="0.000303047"/>
      <origin rpy="0 0 0" xyz="-0.02297 0.00019 0.00119"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RElbowYaw.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>

    <collision>
    <origin rpy="0. 0.2 0" xyz="-0.08 00 0.02"/>
      <geometry>
        <box size = "0.1 0.07 0.07"/>
      </geometry>
      
    </collision>

    
    
  </link>
  <joint name="RElbowRoll" type="revolute">
    <parent link="RElbow"/>
    <child link="RForeArm"/>
    <origin rpy="0 0 0" xyz="0 0 0"/>
    <axis xyz="0 0 1.0"/>
    <limit effort="2.666" lower="0.00872665" upper="1.56207" velocity="9.22756"/>
  </joint>
  <link name="RForeArm">
    <inertial>
      <mass value="0.16579"/>
      <inertia ixx="0.00156513" ixy="-1.47517e-05" ixz="-6.05746e-05" iyy="0.00173219" iyz="1.7619e-07" izz="0.000273081"/>
      <origin rpy="0 0 0" xyz="0.0593 -0.00271 -0.01014"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RElbowRoll.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RWristYaw" type="revolute">
    <parent link="RForeArm"/>
    <child link="r_wrist"/>
    <origin rpy="0 0 0" xyz="0.15 0 0"/>
    <axis xyz="1.0 0 0"/>
    <limit effort="0.2014" lower="-1.82387" upper="1.82387" velocity="17.3835"/>
  </joint>
  <link name="r_wrist">
    <inertial>
      <mass value="0.27555"/>
      <inertia ixx="0.000151643" ixy="-1.06629e-05" ixz="2.89509e-06" iyy="0.000431099" iyz="3.13715e-06" izz="0.000456172"/>
      <origin rpy="0 0 0" xyz="0.03536 0.00072 -0.00207"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RWristYaw.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>

    <collision>
    <origin rpy="0 0 0" xyz="0 0 0"/>
      <geometry>
        <box size = "0.23 0.07 0.07"/>
      </geometry>  
    </collision>
    
  </link>
  <joint name="RHand" type="revolute">
    <parent link="r_wrist"/>
    <child link="r_gripper"/>
    <origin rpy="0 0 0" xyz="0.025 0 0"/>
    <axis xyz="1.0 0 0"/>
    <limit effort="0.144" lower="0" upper="1" velocity="12.56"/>
  </joint>
  <link name="r_gripper">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
  </link>

  <link name="RFinger41_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RFinger41.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RFinger41" type="continuous">
    <parent link="r_wrist"/>
    <child link="RFinger41_link"/>
    <origin rpy="1.74402 1.04064 -0.0683394" xyz="0.074 -0.0309 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LFinger42_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LFinger42.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
    
  </link>
  <joint name="LFinger42" type="continuous">
    <parent link="LFinger41_link"/>
    <child link="LFinger42_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RFinger12_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RFinger12.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RFinger12" type="continuous">
    <parent link="RFinger11_link"/>
    <child link="RFinger12_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LFinger33_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LFinger33.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="LFinger33" type="continuous">
    <parent link="LFinger32_link"/>
    <child link="LFinger33_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RFinger31_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RFinger31.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
  
  </link>
  <joint name="RFinger31" type="continuous">
    <parent link="r_wrist"/>
    <child link="RFinger31_link"/>
    <origin rpy="1.67523 1.04483 0.029316" xyz="0.0833 -0.0123 0.004"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LFinger21_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LFinger21.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
  
  </link>
  <joint name="LFinger21" type="continuous">
    <parent link="l_wrist"/>
    <child link="LFinger21_link"/>
    <origin rpy="1.5708 1.0472 -0.061086" xyz="0.0873 -0.0073 0.006"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RFinger32_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RFinger32.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RFinger32" type="continuous">
    <parent link="RFinger31_link"/>
    <child link="RFinger32_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LFinger13_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LFinger13.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
    
  </link>
  <joint name="LFinger13" type="continuous">
    <parent link="LFinger12_link"/>
    <child link="LFinger13_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LFinger32_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LFinger32.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="LFinger32" type="continuous">
    <parent link="LFinger31_link"/>
    <child link="LFinger32_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LFinger11_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LFinger11.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="LFinger11" type="continuous">
    <parent link="l_wrist"/>
    <child link="LFinger11_link"/>
    <origin rpy="1.74402 1.04064 -0.0334335" xyz="0.0821 -0.0268 0.004"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RFinger22_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RFinger22.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
  
  </link>
  <joint name="RFinger22" type="continuous">
    <parent link="RFinger21_link"/>
    <child link="RFinger22_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RFinger13_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RFinger13.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RFinger13" type="continuous">
    <parent link="RFinger12_link"/>
    <child link="RFinger13_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LFinger22_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LFinger22.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="LFinger22" type="continuous">
    <parent link="LFinger21_link"/>
    <child link="LFinger22_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RFinger21_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RFinger21.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RFinger21" type="continuous">
    <parent link="r_wrist"/>
    <child link="RFinger21_link"/>
    <origin rpy="1.5708 1.0472 0.061086" xyz="0.0873 0.0073 0.006"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LFinger41_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LFinger41.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="LFinger41" type="continuous">
    <parent link="l_wrist"/>
    <child link="LFinger41_link"/>
    <origin rpy="1.39757 1.04064 0.0683394" xyz="0.074 0.0309 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LFinger12_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LFinger12.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="LFinger12" type="continuous">
    <parent link="LFinger11_link"/>
    <child link="LFinger12_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RFinger23_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RFinger23.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RFinger23" type="continuous">
    <parent link="RFinger22_link"/>
    <child link="RFinger23_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RFinger11_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RFinger11.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RFinger11" type="continuous">
    <parent link="r_wrist"/>
    <child link="RFinger11_link"/>
    <origin rpy="1.39757 1.04064 0.0334335" xyz="0.0821 0.0268 0.004"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LFinger23_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LFinger23.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="LFinger23" type="continuous">
    <parent link="LFinger22_link"/>
    <child link="LFinger23_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LFinger43_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LFinger43.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="LFinger43" type="continuous">
    <parent link="LFinger42_link"/>
    <child link="LFinger43_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RFinger43_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RFinger43.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RFinger43" type="continuous">
    <parent link="RFinger42_link"/>
    <child link="RFinger43_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RFinger42_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RFinger42.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
  
  </link>
  <joint name="RFinger42" type="continuous">
    <parent link="RFinger41_link"/>
    <child link="RFinger42_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LFinger31_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LFinger31.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="LFinger31" type="continuous">
    <parent link="l_wrist"/>
    <child link="LFinger31_link"/>
    <origin rpy="1.46636 1.04483 -0.029314" xyz="0.0833 0.0123 0.004"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RFinger33_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RFinger33.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RFinger33" type="continuous">
    <parent link="RFinger32_link"/>
    <child link="RFinger33_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.018 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LThumb1_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LThumb1.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="LThumb1" type="continuous">
    <parent link="l_wrist"/>
    <child link="LThumb1_link"/>
    <origin rpy="-1.95836 0.60626 0.533978" xyz="0.0482 -0.0357 -0.0199"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RThumb2_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RThumb2.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
    
  </link>
  <joint name="RThumb2" type="continuous">
    <parent link="RThumb1_link"/>
    <child link="RThumb2_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.022 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="RThumb1_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/RThumb1.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="RThumb1" type="continuous">
    <parent link="r_wrist"/>
    <child link="RThumb1_link"/>
    <origin rpy="-1.18323 0.60626 -0.533978" xyz="0.0482 0.0357 -0.0199"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="RHand" multiplier="0.872665" offset="0"/>
  </joint>
  <link name="LThumb2_link">
    <inertial>
      <mass value="2e-06"/>
      <inertia ixx="1.1e-09" ixy="0" ixz="0" iyy="1.1e-09" iyz="0" izz="1.1e-09"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/LThumb2.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="LThumb2" type="continuous">
    <parent link="LThumb1_link"/>
    <child link="LThumb2_link"/>
    <origin rpy="0 0 -1.0472" xyz="0.022 0 0"/>
    <axis xyz="0 0 1.0"/>
    <mimic joint="LHand" multiplier="0.872665" offset="0"/>
  </joint>

  <link name="WheelFL_link">
    <inertial>
      <mass value="1.58028"/>
      <inertia ixx="0.00299756" ixy="6.3068e-07" ixz="5.56903e-06" iyy="0.00303229" iyz="-9.0408e-07" izz="0.00296585"/>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/WheelFL.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="WheelFL" type="fixed">
    <parent link="Tibia"/>
    <child link="WheelFL_link"/>
    <origin rpy="0 0 1.07517" xyz="0.09 0.155 -0.264"/>
  </joint>
  <link name="WheelB_link">
    <inertial>
      <mass value="1.58028"/>
      <inertia ixx="0.00299756" ixy="6.3068e-07" ixz="5.56903e-06" iyy="0.00303229" iyz="-9.0408e-07" izz="0.00296585"/>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/WheelB.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
    
  </link>
  <joint name="WheelB" type="fixed">
    <parent link="Tibia"/>
    <child link="WheelB_link"/>
    <origin rpy="0 0 -3.14159" xyz="-0.17 0 -0.264"/>
  </joint>
  <link name="WheelFR_link">
    <inertial>
      <mass value="1.58028"/>
      <inertia ixx="0.00299756" ixy="6.3068e-07" ixz="5.56903e-06" iyy="0.00303229" iyz="-9.0408e-07" izz="0.00296585"/>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </inertial>
    <visual>
      <geometry>
        <mesh filename="package://pepper_description/meshes/WheelFR.dae" scale="0.1 0.1 0.1"/>
      </geometry>
      <origin rpy="0 0 0" xyz="0 0 0"/>
    </visual>
   
  </link>
  <joint name="WheelFR" type="fixed">
    <parent link="Tibia"/>
    <child link="WheelFR_link"/>
    <origin rpy="0 0 -1.07517" xyz="0.09 -0.155 -0.264"/>
  </joint>

  <joint name="fixed_base" type="fixed">
    <parent link="base_link"/>
    <child link="Tibia"/>
    <origin rpy="0 0 0" xyz="0 0 0.334"/>
  </joint>

  <link name="tablet"/>
  <joint name="tablet_fixedjoint" type="fixed">
    <parent link="torso"/>
    <child link="tablet"/>
    <origin rpy="0 -0.523599 0" xyz="0.0839249 0 0.2"/>
    <axis xyz="0 0 0"/>
  </joint>

</robot>`;
